import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;

import java.util.Arrays;


public class YouAreEll {

    String url;

    YouAreEll(String url) {
        this.url=url;
    }
//
//    public static void main(String[] args) throws UnirestException {
//        YouAreEll urlhandler = new YouAreEll("http://zipcode.rocks:8085");
//        System.out.println(urlhandler.MakeURLCall("/ids", "GET", ""));
//        System.out.println(urlhandler.MakeURLCall("/messages", "GET", ""));
//    }

    public static String convertToJson(Object o) {
        ObjectMapper objectMapper = new ObjectMapper();
        String json;
        try {
            json = objectMapper.writeValueAsString(o);
            System.out.println(json);
        } catch (JsonProcessingException e) {
            throw new Error(e);
        }
        return json;
    }

    public String get_ids() throws UnirestException {
        HttpResponse<JsonNode> result = MakeURLCall("/ids", "GET", "");

        return result.getBody().toString();
    }

    public String get_messages() throws UnirestException {
        return MakeURLCall("/messages", "GET", "").getBody().toString();
    }

    public String create_message(Object o) throws UnirestException{
        return MakeURLCall("/ids/boo/messages", "POST", convertToJson(o)).getBody().toString();
    }

    public String create_id(Object o) throws UnirestException {
        return MakeURLCall("/ids","POST", convertToJson(o)).getBody().toString();
    }
    public String replace_id(Object o) throws UnirestException{
        return MakeURLCall("/ids","PUT", convertToJson(o)).getBody().toString();
    }

    public HttpResponse<JsonNode> MakeURLCall(String mainurl, String method, String jpayload) throws UnirestException {
        mainurl = url + mainurl;
        HttpResponse<JsonNode> jsonResponse;

        switch (method) {
            case "GET":
                jsonResponse = Unirest.get(mainurl)
                    .header("accept", "application/json")
                    .asJson();
            break;

            case "POST":
                jsonResponse = Unirest.post(mainurl)
                        .header("accept", "application/json")
                        .body(jpayload)
                        .asJson();
                break;
            case "PUT":
                jsonResponse = Unirest.put(mainurl)
                        .header("accept", "application/json")
                        .body(jpayload)
                        .asJson();
                break;

                default : jsonResponse= Unirest.get(mainurl).asJson();
                break;
        }
        return jsonResponse;
    }

}
